//+------------------------------------------------------------------+
//|                                             Hurst cofficient.mq4 |
//|                                                           mladen |
//|                                                                  |
//| Bob Fulks version                                                |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "nladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    1
#property indicator_color1     Red
#property indicator_level1     0.5
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern int HurstLength  = 30;
extern int AppliedPrice = PRICE_CLOSE;

//
//
//
//
//

double HurstBuffer[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   SetIndexBuffer(0,HurstBuffer); SetIndexDrawBegin(0,HurstLength);
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

#define koef 1.253314
double x[];
double y[];

//
//
//
//
//


int start()
{
   int    counted_bars=IndicatorCounted();
   int    i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
         limit = Bars-counted_bars;
            if (ArraySize(x) != HurstLength)
            {
               ArrayResize(x,HurstLength); ArrayInitialize(x,0); ArraySetAsSeries(x,true);
               ArrayResize(y,HurstLength); ArrayInitialize(y,0); ArraySetAsSeries(y,true);
            }

   //
   //
   //
   //
   //
            
   for (i=limit; i>=0; i--)
   {
      double mean = iMA(NULL,0,HurstLength,0,MODE_SMA,AppliedPrice,i);
      double sums = 0;
      for (int k=0; k <HurstLength; k++)
      {
            x[k] = iMA(NULL,0,1,0,MODE_SMA,AppliedPrice,i+k)-mean;  sums += x[k]*x[k];
      }   

      //
      //
      //
      //
      //
                     
      double maxY = x[0];
      double minY = x[0];
             y[0] = x[0];
          
         for (k=1; k<HurstLength; k++)
         {
               y[k] = y[k-1] + x[k];
               maxY = MathMax(y[k],maxY);
               minY = MathMin(y[k],minY);
         }
      double iValue = 0; if (sums   !=0) iValue = (maxY - minY)/(koef * MathSqrt(sums/HurstLength));
      double hurst  = 0; if (iValue > 0) hurst  = MathLog(iValue)/ MathLog(HurstLength);
            
      HurstBuffer[i] = hurst;
   }            
   return(0);
}